<?php
/**
 * @package		HikaShop for Joomla!
 * @version		1.4.8
 * @author		hikashop.com
 * @copyright	(C) 2010 HIKARI SOFTWARE. All rights reserved.
 * @license		http://www.hikashop.com/commercial_license.php
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgHikashopData_feed extends JPlugin
{
	var $message = '';


	function plgHikashopData_feed(&$subject, $config){
		parent::__construct($subject, $config);
    }

	function onHikashopCronTrigger(&$messages){
		$pluginsClass = hikashop::get('class.plugins');
		$plugin = $pluginsClass->getByName('hikashop','data_feed');
		if(!empty($plugin->params['path']))
			$path=$plugin->params['path'];
		else{
			return true;
		}
		if(!empty($plugin->params['column_name']))
			$column=$plugin->params['column_name'];

		//check extension
		$check=substr($path,-3);
		if($check!='csv')
			return true;

		$path=$this->_getRelativePath($path);
		jimport('joomla.filesystem.file');
		if(!JFile::exists(JPATH_ROOT.DS.$path)){
			return true;
		}

		$path=JURI::base().$path;
		$path=str_replace('administrator','',$path);

		$os=substr(PHP_OS, 0, 3);
		$os=strtolower($os);
		if($os='win')
			$path=str_replace('\\','/',$path);

		if(empty($plugin->params['frequency'])){
			$plugin->params['frequency'] = 86400;
		}
		if(!empty($plugin->params['last_cron_update']) && $plugin->params['last_cron_update']+$plugin->params['frequency']>time()){
			return true;
		}

   		$helper = hikashop::get('helper.import');
   		//product_name,price_value,price_currency_id

		if(isset($column)){
	   		$entries=explode(";",$column);
	   		$i=0;
			foreach($entries as $entry){
				$var=explode(":",$entry);
				$tab[$var[0]]=$var[1];
				$i++;
			}
		}


    	$helper->columnNamesConversionTable = $tab;
   		$helper->createCategories = true;
   		$helper->overwrite = true;
   		$helper->header_errors = false;

   		$contentFile = file_get_contents($path);
		$helper->handleContent($contentFile);
	}

	function _getRelativePath($path){
		$app =& JFactory::getApplication();
		if(!preg_match('#^([A-Z]:)?/.*#',$path)){
			if(!$path[0]=='/' || !is_dir($path)){
				$pathClean = JPath::clean(HIKASHOP_ROOT.DS.trim($path,DS.' ').DS);
			}
		}


		if(!empty($pathClean)){
			$relativePath=str_replace(JPATH_ROOT.DS,'',$pathClean);
		}
		else{
			$relativePath=str_replace(JPATH_ROOT.DS,'',$path);
		}

		$relativePath=substr($relativePath,0,-1);
		return $relativePath;

	}
}


